#include "stdafx.h"
#include "md5.hpp"

namespace Lmt {
	MD5::MD5( void ) {
	}

	MD5::~MD5( void ) {
	}

	void MD5::Start( void ) {
		::md5_starts( &m_ctx );
	}

	void MD5::Update( const void *pbuffer, unsigned int length ) {
		::md5_update( &m_ctx, const_cast<unsigned char*>( reinterpret_cast<const unsigned char*>( pbuffer ) ), length );
	}

	void MD5::Finish( unsigned char *pdigest ) {
		::md5_finish( &m_ctx, pdigest );
	}

	wstring MD5::ToString( const unsigned char *md ) {
		wchar_t buffer[128];

		swprintf( buffer, L"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
			md[0], md[1], md[2], md[3], md[4], md[5], md[6], md[7], 
			md[8], md[9], md[10], md[11], md[12], md[13], md[14], md[15]
		);

		return buffer;
	}
}