#include "StdAfx.h"
#include "TrackElement.hpp"

namespace Lmt {
namespace Max2Bms {
	TrackElement::TrackElement( void ) {
		m_pelement = NULL;
	}

	TrackElement::~TrackElement( void ) {
	}

	int TrackElement::GetPosition( void ) const {
		return m_pelement->position;
	}

	PtTrackElementTypes TrackElement::GetType( void ) const {
		return static_cast<PtTrackElementTypes>( m_pelement->objectType );
	}

	const void * TrackElement::GetDetail() const {
		return m_pelement->detail;
	}

	bool TrackElement::Initialize( const unsigned char *pelement ) {
		if (pelement == NULL) {
			return false;
		}

		m_pelement = reinterpret_cast<const PtFormat::TrackObject*>( pelement );

		return true;
	}
}
}
